#include <dfsch-ext/tcltk.h>

DFSCH_DEFINE_PRIMITIVE(create_interpreter, 0){
  DFSCH_ARG_END(args);
  
  return dfsch_ext_tcl_create_interpreter();
}
DFSCH_DEFINE_PRIMITIVE(eval, 0){
  Tcl_Interp* interp;
  char* code;

  DFSCH_EXT_TCL_INTERPRETER_ARG(args, interp);
  DFSCH_STRING_ARG(args, code);
  DFSCH_ARG_END(args);

  return dfsch_make_string_cstr(dfsch_ext_tcl_eval(interp, code));
}
DFSCH_DEFINE_PRIMITIVE(destroy_interpreter, 0){
  dfsch_object_t* interpreter;
  DFSCH_OBJECT_ARG(args, interpreter);
  DFSCH_ARG_END(args);
  
  dfsch_ext_tcl_destroy_interpreter(interpreter);
  return NULL;
}
DFSCH_DEFINE_PRIMITIVE(wrap_command, 0){
  dfsch_object_t* interpreter;
  char* name;

  DFSCH_STRING_ARG(args, name);
  DFSCH_OBJECT_ARG_OPT(args, interpreter, NULL);
  DFSCH_ARG_END(args);

  return dfsch_ext_tcl_wrap_command(name, interpreter);
}

void dfsch_module_tcltk_register(dfsch_object_t* env){
  dfsch_define_cstr(env, "tcltk:<interpreter>", 
                    DFSCH_EXT_TCL_INTERPRETER_TYPE);
  dfsch_define_cstr(env, "tcltk:<command-wrapper>", 
                    DFSCH_EXT_TCL_COMMAND_WRAPPER_TYPE);

  dfsch_define_cstr(env, "tcltk:create-interpreter", 
                    DFSCH_PRIMITIVE_REF(create_interpreter));
  dfsch_define_cstr(env, "tcltk:destroy-interpreter", 
                    DFSCH_PRIMITIVE_REF(destroy_interpreter));
  dfsch_define_cstr(env, "tcltk:eval", 
                    DFSCH_PRIMITIVE_REF(eval));
  dfsch_define_cstr(env, "tcltk:wrap-command", 
                    DFSCH_PRIMITIVE_REF(wrap_command));

}
